(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('utils-lib-js')) :
    typeof define === 'function' && define.amd ? define(['exports', 'utils-lib-js'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.TaskQueue = {}, global.utilsLibJs));
})(this, (function (exports, utilsLibJs) { 'use strict';

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    var TaskQueue = (function (_super) {
        __extends(TaskQueue, _super);
        function TaskQueue(props) {
            var _this = _super.call(this) || this;
            _this.defaultKey = "default";
            _this.defaultLen = 10;
            _this.push = function (queue, id) {
                if (id === void 0) { id = _this.defaultKey; }
                _this.checkQueue(queue, id);
                var _a = utilsLibJs.defer(), resolve = _a.resolve, reject = _a.reject, promise = _a.promise;
                try {
                    _this.formatQueue(queue, id);
                    _this.run();
                }
                catch (e) {
                    _this.state = "rejected";
                    reject(e);
                }
                _this.on(id, resolve);
                return promise;
            };
            _this.run = function () { return __awaiter(_this, void 0, void 0, function () {
                var queues, result;
                var _this = this;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!!!!(this.state === 'pending' || (this.queues.length === 0 && (this.state = "idle")))) return [3, 2];
                            this.state = "pending";
                            queues = this.unshift((_a = this.props) === null || _a === void 0 ? void 0 : _a.maxLen);
                            return [4, Promise.all(queues.map(function (item) {
                                    var _a;
                                    var res = item.queue();
                                    if (_this.isPromise(res)) {
                                        return (_a = res === null || res === void 0 ? void 0 : res.catch) === null || _a === void 0 ? void 0 : _a.call(res, function (e) { return new Error(e); });
                                    }
                                    return res;
                                }))];
                        case 1:
                            result = _b.sent();
                            this.state = 'fulfilled';
                            this.finish({ result: result, queues: queues });
                            return [3, 0];
                        case 2: return [2];
                    }
                });
            }); };
            _this.finish = function (_a) {
                var _b = _a.result, result = _b === void 0 ? [] : _b, _c = _a.queues, queues = _c === void 0 ? [] : _c;
                var queueTemp = _this.queueTemp;
                queues.forEach(function (it, i) {
                    var _a, _b;
                    var key = it.id;
                    var temp = queueTemp[key];
                    temp.result.push(result[i]);
                    if (((_a = temp.result) === null || _a === void 0 ? void 0 : _a.length) === ((_b = temp.queue) === null || _b === void 0 ? void 0 : _b.length)) {
                        _this.emit(key, temp.result);
                        _this.state = 'idle';
                        queueTemp[key] = null;
                    }
                });
            };
            _this.formatQueue = function (fns, id) {
                var _a;
                var queueTemp = _this.queueTemp;
                var __obj = { id: id, result: [] };
                var it = (_a = queueTemp[id]) !== null && _a !== void 0 ? _a : __assign({ queue: [] }, __obj);
                var tempQueue = it === null || it === void 0 ? void 0 : it.queue;
                fns.forEach(function (queue) {
                    tempQueue.push(queue);
                    _this.queues.push(__assign({ queue: queue }, __obj));
                });
                queueTemp[id] = it;
            };
            _this.isPromise = function (fn) {
                return fn instanceof Promise;
            };
            _this.voidObj = function () { return Object.create(null); };
            _this.unshift = function (length) {
                if (length === void 0) { length = _this.defaultLen; }
                return _this.queues.splice(0, length);
            };
            _this.clearQueue = function () {
                _this.queues = [];
                _this.queueTemp = _this.voidObj();
                _this.props = null;
                _this.state = "idle";
                _this.clear();
            };
            _this.clearQueue();
            _this.props = props;
            return _this;
        }
        TaskQueue.prototype.checkQueue = function (queue, id) {
            if (!queue) {
                throw new ReferenceError('queue is not defined');
            }
            if (!(queue instanceof Array) || typeof queue !== "object") {
                throw new TypeError("queue should be an object and queue should be an array");
            }
            var noFn = function (i) { return !i || typeof i !== "function"; };
            if ((queue === null || queue === void 0 ? void 0 : queue.length) === 0)
                throw new Error('queue.length can not be 0');
            if (queue === null || queue === void 0 ? void 0 : queue.find(function (i) { return noFn(i); }))
                throw new Error('queueList should have fn');
        };
        return TaskQueue;
    }(utilsLibJs.MessageCenter));

    exports.TaskQueue = TaskQueue;
    exports.default = TaskQueue;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
